#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityDBFHandbookCFG.h"
std::auto_ptr<M_ActivityDBFHandbookCFG> M_ActivityDBFHandbookCFG::msSingleton(nullptr);

int M_ActivityDBFHandbookCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityDBFHandbookCFGData* M_ActivityDBFHandbookCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityDBFHandbookCFGData>& M_ActivityDBFHandbookCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityDBFHandbookCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityDBFHandbookCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityDBFHandbookCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mHandbookType = element->IntAttribute("HandbookType");
		data.mHandbookName = element->Attribute("HandbookName");
		data.mItemId = element->IntAttribute("ItemId");
		data.mHandbookResource = element->Attribute("HandbookResource");
		data.mHandbookReward = element->IntAttribute("HandbookReward");
		data.mHandbookQuantity = element->IntAttribute("HandbookQuantity");
		data.mRepeatReward = element->IntAttribute("RepeatReward");
		data.mRepeatQuantity = element->IntAttribute("RepeatQuantity");
		data.mLotteryWeight = element->IntAttribute("LotteryWeight");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityDBFHandbookCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityDBFHandbookCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityDBFHandbookCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityDBFHandbookCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityDBFHandbookCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "HandbookType", data.mHandbookType);
		LuaCfgHelper::readString(L, "HandbookName", data.mHandbookName);
		LuaCfgHelper::readInt(L, "ItemId", data.mItemId);
		LuaCfgHelper::readString(L, "HandbookResource", data.mHandbookResource);
		LuaCfgHelper::readInt(L, "HandbookReward", data.mHandbookReward);
		LuaCfgHelper::readInt(L, "HandbookQuantity", data.mHandbookQuantity);
		LuaCfgHelper::readInt(L, "RepeatReward", data.mRepeatReward);
		LuaCfgHelper::readInt(L, "RepeatQuantity", data.mRepeatQuantity);
		LuaCfgHelper::readInt(L, "LotteryWeight", data.mLotteryWeight);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityDBFHandbookCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityDBFHandbookCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityDBFHandbookCFG* M_ActivityDBFHandbookCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityDBFHandbookCFG());
	}
	return msSingleton.get();
}

void M_ActivityDBFHandbookCFG::Release()
{
	msSingleton.reset(nullptr);
}
